/****************************************************************************
 * Structures used in JWM.
 * Copyright (C) 2004 Joe Wingbermuehle
 ****************************************************************************/

#ifndef STRUCT_H
#define STRUCT_H

/****************************************************************************
 ****************************************************************************/
typedef struct {
	int minx, maxx;
	int miny, maxy;
} AspectRatio;

/****************************************************************************
 ****************************************************************************/
typedef struct ClientNode {
	Window window;
	Window parent;
	GC parentGC;
	int desktop;

	Window owner;
	Window icon;

	int x, y, width, height;
	int oldx, oldy, oldWidth, oldHeight;

	long sizeFlags;
	int baseWidth, baseHeight;
	int minWidth, minHeight;
	int maxWidth, maxHeight;
	int xinc, yinc;
	AspectRatio aspect;
	int gravity;

	Colormap colorMap;
	char *name;

	BorderFlags borderFlags;
	BorderActionType borderAction;

	ClientProtocolType protocols;
	StatusFlags statusFlags;
	int layer;

	void (*controller)(int wasDestroyed);

	struct ClientNode *prev;
	struct ClientNode *next;
} ClientNode;

/****************************************************************************
 ****************************************************************************/
typedef struct MenuItemType {
	char *name;
	char *command;
	struct MenuItemType *next;
	void *submenu;  /* struct MenuType* */
} MenuItemType;

/****************************************************************************
 ****************************************************************************/
typedef struct MenuType {
	/* This field must be set before calling ShowMenu */
	MenuItemType *items;

	/* These fields are handled by menu.c */
	Window window;
	GC gc;
	int x, y;
	int width, height;
	int currentIndex, lastIndex;
	int itemCount;
	int parentOffset;
	int wasCovered;
	int *offsets;
	struct MenuType *parent;
} MenuType;

/****************************************************************************
 ****************************************************************************/
typedef struct AttributeNode {
	char *name;
	char *value;
	struct AttributeNode *next;
} AttributeNode;

/****************************************************************************
 ****************************************************************************/
typedef struct TokenNode {
	TokenType type;
	char *value;
	AttributeNode *attributes;
	struct TokenNode *parent;
	struct TokenNode *subnodeHead, *subnodeTail;
	struct TokenNode *next;
} TokenNode;

#endif

